// This file is part of the PngOptimizerCL application
// Copyright (C) 2002/2007 Hadrien Nilsson - psydk.org
// For conditions of distribution and use, see copyright notice in PngOptimizer.h
/////////////////////////////////////////////////////////////////////////////////////

#ifndef POCL_ARGVPARSER_H
#define POCL_ARGVPARSER_H


// This class allows to parse arguments from the command line
class ArgvParser  
{
public:
	ArgvParser(const String& strCmdLine);

	// Returns true if a flag word is present in the command line
	// Example: compil -Verbose // GetFlag("verbose") returns true
	bool GetFlag(const String& strFlagName) const;

	// Returns the value assigned to a flag
	// Example: run -value:"100" // GetFlagString("value") returns "100"
	String GetFlagString(const String& strFlagName) const;
	
	virtual ~ArgvParser();

protected:
	String m_strCmdLine;

	class Arg
	{
	public:
		bool m_bFlag;
		String m_strName;
		String m_strFlagString;
	};
	Array<Arg> m_aArgs;

private:
	void Parse();
	void ConvertToArgs(const StringArray& astrArgs);
	int32 GetFlagIndex(const String& strFlagName) const;
	const wchar* JumpOverExeName(const wchar* pszCmdLine);
};

#endif // ndef POCL_ARGVPARSER_H
