///////////////////////////////////////////////////////////////////////////////
// This file is part of the chustd library
// Copyright (C) 2005/2008 ChuTeam
// For conditions of distribution and use, see copyright notice in chustd.h
///////////////////////////////////////////////////////////////////////////////

#ifndef CHUSTD_FORMATTYPE_H
#define CHUSTD_FORMATTYPE_H

namespace chustd
{
	void FormatInt32(int32 nValue, wchar* pszBuffer); // pszBuffer : 12 chars
	void FormatInt64(int64 nValue, wchar* pszBuffer); // pszBuffer : 22 chars

	void FormatUInt32(uint32 nValue, wchar* pszBuffer); // pszBuffer : 12 chars
	void FormatUInt64(uint64 nValue, wchar* pszBuffer); // pszBuffer : 24 chars

	void FormatInt32(int32 nValue, wchar* pszBuffer, int8 nWidth, wchar cFill); // pszBuffer : 12 chars
	void FormatInt64(int64 nValue, wchar* pszBuffer, int8 nWidth, wchar cFill); // pszBuffer : 22 chars

	void FormatUInt32(uint32 nValue, wchar* pszBuffer, int8 nWidth, wchar cFill); // pszBuffer : 12 chars
	void FormatUInt64(uint64 nValue, wchar* pszBuffer, int8 nWidth, wchar cFill); // pszBuffer : 24 chars

	void FormatPtr(void* p, wchar* pszBuffer); // pszBuffer : 20 chars
	
	void FormatUInt8Hex(uint8 nValue, wchar* pszBuffer); // pszBuffer : 12 chars
	void FormatUInt16Hex(uint16 nValue, wchar* pszBuffer); // pszBuffer : 12 chars
	void FormatUInt32Hex(uint32 nValue, wchar* pszBuffer); // pszBuffer : 12 chars
	void FormatUInt32Hex(uint32 nValue, wchar* pszBuffer, int8 nWidth, wchar cFill); // pszBuffer : 12 chars

	void FormatUInt8Bin(uint8 nValue, wchar* pszBuffer); // pszBuffer : 9 chars
	void FormatUInt16Bin(uint16 nValue, wchar* pszBuffer); // pszBuffer : 17 chars
	void FormatUInt32Bin(uint32 nValue, wchar* pszBuffer); // pszBuffer : 33 chars
	void FormatUInt32Bin(uint32 nValue, wchar* pszBuffer, int8 nWidth, wchar cFill); // pszBuffer : 33 chars
}

#endif // ndef CHUSTD_FORMATTYPE_H
