///////////////////////////////////////////////////////////////////////////////
// This file is part of the chustd library
// Copyright (C) 2005/2008 ChuTeam
// For conditions of distribution and use, see copyright notice in chustd.h
///////////////////////////////////////////////////////////////////////////////

#ifndef CHUSTD_POINT_H
#define CHUSTD_POINT_H

namespace chustd {

class Point  
{
public:
	int32 m_nX;
	int32 m_nY;

public:
	int32 ComputeOffset(int nLineOffset) const { return m_nY * nLineOffset + m_nX; }

public:
	Point(int32 nX, int32 nY)
	{
		m_nX = nX;
		m_nY = nY;
	}

	Point()
	{
		m_nX = 0;
		m_nY = 0;
	}

	bool operator==(const Point& pt) const;
	
	friend const Point operator+(Point pt1, Point pt2);
	friend const Point operator-(Point pt1, Point pt2);
};

}

#endif // ndef CHUSTD_POINT_H
