///////////////////////////////////////////////////////////////////////////////
// This file is part of the chustd library
// Copyright (C) 2005/2008 ChuTeam
// For conditions of distribution and use, see copyright notice in chustd.h
///////////////////////////////////////////////////////////////////////////////

#include "Master.h"
#include "Random.h"
#include "System.h"

//////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////
using namespace chustd;
//////////////////////////////////////////////////////////////////////

Random::Random()
{
	m_nModulus	= 2147483647;	// 2^31 - 1
	m_nMultiplier = 16807;		// 7^5
	m_nNumber = System::GetTime();
}

Random::~Random()
{

}

// Not a very good algorithm, but enough for now
int32 Random::GetNext(int32 nMin, int32 nMax)
{
	if( !(nMax > nMin) )
	{
		return 0;	
	}

	int64 nTmp = m_nNumber;
	nTmp *= m_nMultiplier;
	nTmp = nTmp % m_nModulus;

	nTmp &= 0x7fffffff;
	m_nNumber = uint32(nTmp);

	int64 nResult = m_nNumber;
	int32 nRange = (nMax - nMin) + 1;
	nResult *= nRange;
	nResult >>= 31;

	int32 nRand = nMin + int32(nResult);

	return nRand;
}