///////////////////////////////////////////////////////////////////////////////
// This file is part of the chustd library
// Copyright (C) 2005/2008 ChuTeam
// For conditions of distribution and use, see copyright notice in chustd.h
///////////////////////////////////////////////////////////////////////////////

#include "Master.h"
#include "Surface8.h"

//////////////////////////////////////////////////////////////////////
using namespace chustd;
//////////////////////////////////////////////////////////////////////

bool Surface8::SetBuffer(void* pBuffer, int32 nWidth, int32 nHeight, int32 nPitch)
{
	return super::SetBuffer(pBuffer, nWidth, nHeight, nPitch, 8);
}

void Surface8::Fill(uint8 nValue) const
{
	const int32& nHeight = GetHeight();
	const int32& nWidth = GetWidth();
	const int32& nPitch = GetPitch();

	const int32 nNextRowOffset = nPitch - nWidth;

	uint8* pPixels = (uint8*) GetBuffer();

	for( int32 iY = 0; iY < nHeight; ++iY )
	{
		for( int32 iX = 0; iX < nWidth; ++iX )
		{
			pPixels[0] = nValue;
			pPixels++;
		}

		pPixels += nNextRowOffset;
	}
}
