///////////////////////////////////////////////////////////////////////////////
// This file is part of the chustd library
// Copyright (C) 2005/2008 ChuTeam
// For conditions of distribution and use, see copyright notice in chustd.h
///////////////////////////////////////////////////////////////////////////////

#ifndef CHUSTD_SURFACEBASEIMPL_H
#define CHUSTD_SURFACEBASEIMPL_H

// Private header

namespace chustd {

class SurfaceBaseImpl
{
public:
	void* m_pBuffer;
	int32 m_nWidth;
	int32 m_nHeight;
	int32 m_nPitch;      // In pixels
	int32 m_nDstOffsetX; // The offset to apply when drawing
	int32 m_nDstOffsetY; // The offset to apply when drawing
	int8 m_nBitsPerPixel;
	bool m_bOwnBuffer;

	SurfaceBaseImpl()
	{
		m_pBuffer = null;
		m_nWidth = 0;
		m_nHeight = 0;
		m_nPitch = 0;
		m_nDstOffsetX = 0;
		m_nDstOffsetY = 0;
		m_nBitsPerPixel = 0;
		m_bOwnBuffer = 0;
	}
};
}

#endif // ndef CHUSTD_SURFACEBASEIMPL_H