///////////////////////////////////////////////////////////////////////////////
// This file is part of the chustd library
// Copyright (C) 2005/2008 ChuTeam
// For conditions of distribution and use, see copyright notice in chustd.h
///////////////////////////////////////////////////////////////////////////////

#ifndef CHUSTD_TCPCLIENTSOCKET_H
#define CHUSTD_TCPCLIENTSOCKET_H

#include "Socket.h"

namespace chustd {

// Manages incoming information from a socket in TCP mode
class TcpClientSocket : public Socket
{
	typedef Socket super;
public:
	///////////////////////////////////////////////////////
	// Connects the client socket to a server
	bool Connect(const String& strServerName, uint16 nPort);

	// Handler called once connected
	bool AsyncConnect(const String& strServerName, uint16 nPort, PFN_ASYNCHANDLER pfnHandler);
	
private:
	bool Connect2(const String& strServerName, uint16 nPort, bool bAsync);
};

} // namespace chustd

#endif // ndef CHUSTD_TCPCLIENTSOCKET_H
