///////////////////////////////////////////////////////////////////////////////
// This file is part of the chustd library
// Copyright (C) 2005/2008 ChuTeam
// For conditions of distribution and use, see copyright notice in chustd.h
///////////////////////////////////////////////////////////////////////////////

#ifndef CHUSTD_UDPCLIENTSOCKET_H
#define CHUSTD_UDPCLIENTSOCKET_H

#include "Socket.h"

namespace chustd {

// Manages data transmission through an UDP socket
class UdpSocket : public Socket
{
	typedef Socket super;
public:
	int32 SendTo(void* pBuffer, int32 nBufferSize, int32 nFlags, uint32 nIpAddress, uint16 nPort);
	int32 ReceiveFrom(void* pBuffer, int32 nBufferSize, int32 nFlags, uint32& nIpAddress, uint16& nPort);
};

} // namespace chustd

#endif // ndef CHUSTD_UDPCLIENTSOCKET_H
