#include "../Master.h"
#include "../Memory.h"

extern "C" {

#include "chu_ftstdlib.h"

__declspec(noreturn) void __cdecl ft_longjmp(ft_jmp_buf /*onk*/, int /*nPlop*/)
{

}

int __cdecl ft_setjmp(ft_jmp_buf /*youpla*/)
{
	return 0;
}

	
void* ft_memset(void* dest, int c, int count)
{
	chustd::Memory::Set(dest, uint8(c), count);
	return dest;
}

int ft_strlen(const char* psz)
{
	const char* pszFirst = psz;
	while(*psz)
	{
		psz++;
	}

	int nLength = int(psz - pszFirst);
	return nLength;
}

void* ft_memcpy(void* dest, const void* src, int count)
{
	chustd::Memory::Copy(dest, src, count);
	return dest;
}

int ft_strcmp(const char* psz1, const char* psz2)
{
	int32 nLength1 = ft_strlen(psz1);
	int32 nLength2 = ft_strlen(psz2);

	if( nLength1 != nLength2)
		return -1;

	bool bEqual = chustd::Memory::IsEqual(psz1, psz2, nLength1);
	if( bEqual)
		return 0;

	return -1;
}

char* ft_strcpy(char* pszDst, const char* pszSrc)
{
	int nLength = ft_strlen(pszSrc);
	chustd::Memory::Copy(pszDst, pszSrc, nLength + 1);
	return pszDst;
}

char* ft_strncpy(char* pszDst, const char* pszSrc, int nCount)
{
	int nSrcLength = ft_strlen(pszSrc);
	if( nCount <= nSrcLength)
	{
		chustd::Memory::Copy(pszDst, pszSrc, nCount);
		return pszDst;
	}

	chustd::Memory::Copy(pszDst, pszSrc, nSrcLength);
	chustd::Memory::Set(pszDst + nSrcLength, 0, nCount - nSrcLength);
	return pszDst;
}

char* ft_strcat(char* pszDst, const char* pszSrc)
{
	int nDstLength = ft_strlen(pszDst);
	int nSrcLength = ft_strlen(pszSrc);
	chustd::Memory::Copy(pszDst + nDstLength, pszSrc, nSrcLength + 1);
	return pszDst;
}

const char* ft_strrchr(const char* psz, int c)
{
	int nLength = ft_strlen(psz);
	for(int i = nLength - 1; i >= 0; --i)
	{
		if( psz[i] == char(c))
		{
			return psz + i;
		}
	}
	return null;
}

/////////////////////////////////////////////////////////////////////
void* ft_alloc2(int size)
{
	return chustd::Memory::Alloc64(size);
}

void* ft_realloc2(void* memblock, int size)
{
	void* pNew = chustd::Memory::Alloc64(size);
	chustd::Memory::Copy(pNew, memblock, size);

	chustd::Memory::Free64(memblock);
	return pNew;
}

void ft_free2(void* memblock)
{
	chustd::Memory::Free64(memblock);
}

} // extern "C"