///////////////////////////////////////////////////////////////////////////////
// This file is part of the chuwin32 library
// Copyright (C) 2005/2008 ChuTeam
// For conditions of distribution and use, see copyright notice in chuwin32.h
///////////////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "gui.h"

using namespace chuwin32;

bool EditBox::Create(const RECT& rc, HWND hParent, int nId)
{
	HINSTANCE hInstance = GetModuleHandle(NULL);

	int nExStyle = WS_EX_CLIENTEDGE;
	int nStyle = WS_TABSTOP | WS_CHILD | WS_VISIBLE | ES_AUTOHSCROLL;
	
	m_hWnd = ::CreateWindowExW(
		nExStyle,			// extended window style
		L"EDIT",	// registered class name
		L"",	// window name
		nStyle,	// window style
		rc.left,			// horizontal position of window
		rc.top,			// vertical position of window
		rc.right - rc.left,		// window width
		rc.bottom - rc.top,		// window height
		hParent,		// handle to parent or owner window
		HMENU( LongToHandle(nId)),		// menu handle or child identifier
		hInstance,		// handle to application instance (Windows NT/2000/XP: This value is ignored)
		NULL		// window-creation data
		);

	return m_hWnd != NULL;
}
